/*	The implementation of the PerfRect class.
 *
 *	Created by :    Bala'zs Gero"fi (kedli@inf.elte.hu)
 *                      Ga'bor Bala'zs (bege@inf.elte.hu)       [2003.05.16]
 */

#include "perfrect.h"

/* this is column contignous writing mode */
int PerfRect::matrix[4][4] = {
	{0,0,0,1},
	{0,0,1,0},
	{1,0,1,1},
	{0,1,1,1}
};
/* so this matrix show this:
 *
 *   0 0 1 0 
 *   0 0 0 1
 *   0 1 1 1
 *   1 0 1 1
 */

PerfRect::PerfRect()
{
  for(int y = 0; y < 4; ++y)
    for(int x = 0; x < 4; ++x)
	rect[x][y][0] = matrix[x][y];

  for(int z = 1; z < 16; ++z)
    for(int y = 0; y < 4; ++y)
      for(int x = 0; x < 4; ++x)
	rect[x][y][z] = rect[(x + z / 4) % 4][(y + z % 4) % 4][z-1];
}

PerfRect::~PerfRect()
{
}

int PerfRect::hash(int i, int j, int k)
{
  int value = 0;

  for(int z=0; z<2; ++z)
    for(int y=0; y<2; ++y)
      for(int x=0; x<2; ++x)
	value = value * 2 + rect[(i+x)%4][(j+y)%4][(k+z)%16];

  return value;
}

bool PerfRect::testing()
{
  // show the number of the different subcubes
  int using_table[256];

  for(int i=0; i<256; ++i) using_table[i] = 0;

  for(int k=0; k<16; ++k)
    for(int j=0; j<4; ++j)
      for(int i=0; i<4; ++i)
	++using_table[ hash(i, j, k) ];

  for(int i=0; i<256; ++i) if(using_table[i] != 1) return false;
  return true;
}

void PerfRect::mul(int n)
{
  for(int z = 0; z < 16; ++z)
    for(int y = 0; y < 4; ++y)
      for(int x = 0; x < 4; ++x)
	rect[x][y][z] *= n;
}

void PerfRect::alter(int alt)
{
  int altcube[2][2][2];

  // generating the alter cube from hash value alt
  for(int z = 0; z < 2; ++z)
    for(int y = 0; y < 2; ++y)
      for(int x = 0; x < 2; ++x) {
	altcube[x][y][z] = alt % 4;
	alt /= 4;
      }

  // add this alter cube to all blocks
  for(int z = 0; z < 8; ++z )
   for(int y = 0; y < 2; ++y )
    for(int x = 0; x < 2; ++x )

	for(int k = 0; k < 2; ++k )
	  for(int j = 0; j < 2; ++j )
	    for(int i = 0; i < 2; ++i )
		rect[2*x+i][2*y+j][2*z+k] += altcube[i][j][k];     
}

