/*	The class of the perfect rectangle.
 *
 *	The size of the rectangle is 4x4x16.
 *	The size of the subcube is 2x2x2.
 *
 *	Created by :	Bala'zs Gero"fi (kedli@inf.elte.hu)
 *			Ga'bor Bala'zs (bege@inf.elte.hu)	[2003.05.16]
 */

#ifndef PERFRECT_H
#define PERFRECT_H

class PerfRect
{
  public:
	PerfRect();
	~PerfRect();

	// test the rectangle whether it is really perfect
	bool testing();

	// mul all elements in the rectangle by n
	void mul(int n);

	// add the suitable alter subcube (described by hash value alt) to all
	// blocks in the rectangle
	void alter(int alt);

	int at(int i, int j, int k) { return rect[i][j][k]; }

  private:
	// give back the hash value of the pointed subcube
	int hash(int i, int j, int k);

	static int matrix[4][4];  // a perfect matrix
	int rect[4][4][16];  // the rectangle
};

#endif	/* PERFRECT_H */

